module ComunikaGsm
  module Device
    @@devices = []

    def self.ports
      ports = %x{ls /dev | grep ttyUSB*}.split(/\n/)
    end

    ## Get all devices intances
    def self.all
      @@devices
    end

    def self.clear
      @devices = []
    end

    # Initialize devices
    def self.load(params={})
      self.clear
      threads = []
      self.ports.each do |port|
        threads << Thread.new {
          ## Check port and add in to devices ##
          modem = self.load_modem(port, params[:debug])
          if modem
            self.add(modem)
          end

          Thread.current.kill
        }
      end

      while threads.count > 0
        threads.delete_if {|t| !t.alive? }
      end

      @@devices
      #@@devices.collect! {|d| Device.new(d) }#.uniq {|d| d[:imei] }#.find_all{|dev| dev.status == true }.uniq!{|d| d.imei }
    end

    def self.add(device)
      @@devices << device
    end

    def self.load_modem(port, debug=false)
      gsm = GSM2.new(:port => port, :debug => debug)
      if gsm.status
        result = gsm.cmd("AT\r\n")
        if result.to_s.length > 0
          imei = gsm.cmd("AT+CGSN\r\n")
          iccid = gsm.cmd("AT+CRSM=176,12258,0,0,10\r\n")
          provider = gsm.cmd("AT+COPS?\r\n")
          signal = gsm.cmd("AT+CSQ\r\n")
          unless @@devices.find {|m| m[:imei] == imei}
            return Device.new(:port => port,:gsm => gsm, :imei => imei, :iccid => iccid, :provider => provider, :signal => signal)
          end
        else
          gsm.close
          return nil
        end
      end
    end

    class Device
      attr_accessor :port, :gsm, :imei, :iccid, :provider, :signal
      def initialize(params)
        @port = params[:port]; @gsm = params[:gsm]; @imei = params[:imei]; @iccid = params[:iccid]; @provider = params[:provider]; @signal = params[:signal]
      end
    end
  end
end
