module ComunikaGsm
  module PDU
    include ComunikaGsm
    def self.encode(num, message, params = {})
      return unless message
      return unless num
      result = @@pdu_converter.call("stringToPDU",message,num,params[:smsc] || '',params[:ecoding] || 7,params[:sms_class] || 1,params[:valid],params[:deliver] || true,params[:valid_flag] || false)
      self.parse_json(result)
    end

    def self.decode(pdu)
      result = @@pdu_converter.call("getPDUMetaInfo", pdu)
      self.parse_json(result)
    end

    def self.parse_json(value)
      JSON.parse(value, :symbolize_names => true) ## Return hash with name in format symbol
    end

    class PDUDecode
      attr_accessor :id, :size, :pdu, :smsc, :number, :sms_id, :status,
                    :tp_pid, :tp_dcs_popis, :message, :length, :validity, :connection, :mlenght
      attr_writer :sent_at, :receipt_at, :mtype
      def initialize(params)
        @id = params[:id]; @size = params[:size]; @pdu = params[:pdu]; @mtype = params[:mtype]; @smsc = params[:smsc]
        @number = params[:number]; @sms_id = params[:sms_id]; @sent_at = params[:sent_at]; @discharge_at = params[:receipt_at]
        @status = params[:status]; @tp_pid = params[:tp_pid]; @tp_dcs_popis = params[:tp_dcs_popis]; @message = params[:message]
        @length = params[:mlength]; @validity = params[:validity]; @mtype = params[:mtype]
        @connection = params[:connection]
      end

      def decode
        PDU.decode(self.pdu).each {|k,v| instance_variable_set("@#{k.to_s}",v)}
        self
      end

      def sent_at
        Time.parse(@sent_at.sub(/(\d+)\D+(\d+)\D+(\d+)/, '\1/\2/20\3')).strftime('%Y/%m/%d %H:%M:%S') rescue nil
      end

      def receipt_at
        Time.parse(@receipt_at.sub(/(\d+)\D+(\d+)\D+(\d+)/, '\1/\2/20\3')).strftime('%Y/%m/%d %H:%M:%S') rescue nil
      end

      def mtype
        case @mtype
        when 'Receipt requested'
          'INCOMING'
        when 'Status Report'
          'REPORT'
        when 'Unknown Message'
          'REPORT'
        when 'Receive message'
          'INCOMING'
        when 'Data Header'
          'MULTIPART'
        else
          'UNKNOWN'
        end
      end

      def delete
        @connection.cmd("AT+CMGD=#{@id}\r\n")
      end
    end
  end
end
